process control_teclado ()
begin
    priority=1000;
    loop
        if (key(_TECLADO_UP)) teclas[_KEY_UP]++; else teclas[_KEY_UP]=0; end
        if (key(_TECLADO_DOWN)) teclas[_KEY_DOWN]++; else teclas[_KEY_DOWN]=0; end
        if (key(_TECLADO_LEFT)) teclas[_KEY_LEFT]++; else teclas[_KEY_LEFT]=0; end
        if (key(_TECLADO_RIGHT)) teclas[_KEY_RIGHT]++; else teclas[_KEY_RIGHT]=0; end
        if (key(_TECLADO_ACCEPT)) teclas[_KEY_ACCEPT]++; else teclas[_KEY_ACCEPT]=0; end
        if (key(_TECLADO_BACK)) teclas[_KEY_BACK]++; else teclas[_KEY_BACK]=0; end
        if (key(_TECLADO_INTRO)) teclas[_KEY_INTRO]++; else teclas[_KEY_INTRO]=0; end
        if (key(_TECLADO_ESC)) teclas[_KEY_ESC]++; else teclas[_KEY_ESC]=0; end
        if (key(_TECLADO_VOL_UP)) teclas[_KEY_VOL_UP]++; else teclas[_KEY_VOL_UP]=0; end
        if (key(_TECLADO_VOL_DOWN)) teclas[_KEY_VOL_DOWN]++; else teclas[_KEY_VOL_DOWN]=0; end
        if (key(_TECLADO_1)) teclas[_KEY_1]++; else teclas[_KEY_1]=0; end
        if (key(_TECLADO_2)) teclas[_KEY_2]++; else teclas[_KEY_2]=0; end
        if (key(_TECLADO_3)) teclas[_KEY_3]++; else teclas[_KEY_3]=0; end
        if (key(_TECLADO_4)) teclas[_KEY_4]++; else teclas[_KEY_4]=0; end
        if (mouse.left) teclas[_KEY_MOUSE]++; else teclas[_KEY_MOUSE]=0; end
        frame;
    end
end

process control_gp2x ()
begin
    priority=1000;
    loop
        if (joy_getbutton(0,_GP2X_UP)) teclas[_KEY_UP]++; else teclas[_KEY_UP]=0; end
        if (joy_getbutton(0,_GP2X_DOWN)) teclas[_KEY_DOWN]++; else teclas[_KEY_DOWN]=0; end
        if (joy_getbutton(0,_GP2X_LEFT)) teclas[_KEY_LEFT]++; else teclas[_KEY_LEFT]=0; end
        if (joy_getbutton(0,_GP2X_RIGHT)) teclas[_KEY_RIGHT]++; else teclas[_KEY_RIGHT]=0; end
        if (joy_getbutton(0,_GP2X_ACCEPT)) teclas[_KEY_ACCEPT]++; else teclas[_KEY_ACCEPT]=0; end
        if (joy_getbutton(0,_GP2X_BACK)) teclas[_KEY_BACK]++; else teclas[_KEY_BACK]=0; end
        if (joy_getbutton(0,_GP2X_INTRO)) teclas[_KEY_INTRO]++; else teclas[_KEY_INTRO]=0; end
        if (joy_getbutton(0,_GP2X_ESC)) teclas[_KEY_ESC]++; else teclas[_KEY_ESC]=0; end
        if (joy_getbutton(0,_GP2X_VOL_UP)) teclas[_KEY_VOL_UP]++; else teclas[_KEY_VOL_UP]=0; end
        if (joy_getbutton(0,_GP2X_VOL_DOWN)) teclas[_KEY_VOL_DOWN]++; else teclas[_KEY_VOL_DOWN]=0; end
        if (joy_getbutton(0,_GP2X_1)) teclas[_KEY_1]++; else teclas[_KEY_1]=0; end
        if (joy_getbutton(0,_GP2X_2)) teclas[_KEY_2]++; else teclas[_KEY_2]=0; end
        if (joy_getbutton(0,_GP2X_3)) teclas[_KEY_3]++; else teclas[_KEY_3]=0; end
        if (joy_getbutton(0,_GP2X_4)) teclas[_KEY_4]++; else teclas[_KEY_4]=0; end
        if (mouse.left) teclas[_KEY_MOUSE]++; else teclas[_KEY_MOUSE]=0; end
        frame;
    end
end

process control_inclinacion ()
private
    int ci_lateral[15];
    int ci_vertical[15];
    int ci_indice_lat;
    int ci_indice_vert;
    int ci_accel1, ci_accel2, ci_accel3;
    
    int temp;
    int cont;
begin
    priority=1000;
    loop
        //Obtenemos los datos
        joy_getaccel(0, &ci_accel1, &ci_accel2, &ci_accel3);
        //Los aadimos al array, sobreescribiendo el ms antiguo
        ci_lateral[ci_indice_lat & 15]=ci_accel1;
        ci_vertical[ci_indice_vert & 15]=ci_accel2;
        
        //obtenemos el valor medio del array lateral
        temp=0;
        for (cont=0; cont<16; cont++)
            temp+=ci_lateral[cont];
        end
        inclinacion_lateral = temp >> 4;
        //obtenemos el valor medio del array vertical
        temp=0;
        for (cont=0; cont<16; cont++)
            temp+=ci_vertical[cont];
        end
        inclinacion_vertical = temp >> 4;
        frame;
    end
end

process calibrar_inclinacion ()
private
    int textos[13];
    
    int ci_inclinacion_vert_ant, ci_inclinacion_vert_new;
    int ci_inclinacion_lat_ant, ci_inclinacion_lat_new;
    
    int ci_cont_calibracion;
    int ci_lat[149],ci_vert[149];
    int ci_sum_lat,ci_sum_vert;
    string ci_cadena_completado;
begin
    set_text_color(rgb(170,225,190));
    text_z=-254;
    textos[0]=write(0,162,102,1,"CALIBRATING ACCELEROMETERS.");
    textos[1]=write(0,162,110,1,"PLEASE, KEEP THE CONSOLE IN FRONT OF YOU");
    textos[2]=write(0,162,118,1,"AND DON'T MOVE IT!!!");
    textos[3]=write(0,162,132,1,"CALIBRANDO LOS ACELEROMETROS.");
    textos[4]=write(0,162,140,1,"POR FAVOR, MANTEN LA CONSOLA FRENTE A TI");
    textos[5]=write(0,162,148,1,"Y NO LA MUEVAS!!!");
    textos[12]=write(0,162-(text_width(0,"OOOOOOOOOOOOOOO")/2),202,0,"OOOOOOOOOOOOOOO");
    set_text_color(rgb(0,64,21));
    text_z=-255;
    textos[6]=write(0,160,100,1,"CALIBRATING ACCELEROMETERS.");
    textos[7]=write(0,160,108,1,"PLEASE, KEEP THE CONSOLE IN FRONT OF YOU");
    textos[8]=write(0,160,116,1,"AND DON'T MOVE IT!!!");
    textos[9]=write(0,160,130,1,"CALIBRANDO LOS ACELEROMETROS.");
    textos[10]=write(0,160,138,1,"POR FAVOR, MANTEN LA CONSOLA FRENTE A TI");
    textos[11]=write(0,160,146,1,"Y NO LA MUEVAS!!!");
    textos[13]=write_string(0,160-(text_width(0,"OOOOOOOOOOOOOOO")/2),200,0,&ci_cadena_completado);
    
    //Compas de espera
    frame(5000);
    ci_inclinacion_vert_new=inclinacion_vertical;
    ci_inclinacion_lat_new=inclinacion_lateral;
    while ((abs(ci_inclinacion_vert_ant-ci_inclinacion_vert_new) > 5) ||
            (abs(ci_inclinacion_lat_ant-ci_inclinacion_lat_new) > 5))
        ci_inclinacion_vert_ant=ci_inclinacion_vert_new;
        ci_inclinacion_lat_ant=ci_inclinacion_lat_new;
        frame;
    end
    
    //CALIBRANDO
    while (ci_cont_calibracion < 150)
        ci_inclinacion_vert_new=inclinacion_vertical;
        ci_inclinacion_lat_new=inclinacion_lateral;
        if ((abs(ci_inclinacion_vert_ant-ci_inclinacion_vert_new) > 5) ||
                (abs(ci_inclinacion_lat_ant-ci_inclinacion_lat_new) > 5))
            ci_cont_calibracion=0;
            ci_cadena_completado="";
        else
            ci_lat[ci_cont_calibracion]=ci_inclinacion_lat_new;
            ci_vert[ci_cont_calibracion]=ci_inclinacion_vert_new;
            if ((ci_cont_calibracion % 10) == 9) ci_cadena_completado+="O"; end
            ci_cont_calibracion++;
        end
        
        ci_inclinacion_vert_ant=ci_inclinacion_vert_new;
        ci_inclinacion_lat_ant=ci_inclinacion_lat_new;
        frame;
    end
    
    ci_sum_lat=0;
    ci_sum_vert=0;
    for (ci_cont_calibracion=0;ci_cont_calibracion<150;ci_cont_calibracion++)
        ci_sum_lat+=ci_lat[ci_cont_calibracion];
        ci_sum_vert+=ci_vert[ci_cont_calibracion];
    end
    inclinacion_lateral_default=ci_sum_lat/150;
    inclinacion_vertical_default=ci_sum_vert/150;
    
    for (ci_cont_calibracion=0;ci_cont_calibracion<150;ci_cont_calibracion++)
        delete_text(textos[ci_cont_calibracion]);
    end
    //write(0,0,240,6,"Lat: "+inclinacion_lateral_default+ "Vert: "+inclinacion_vertical_default);
    
    signal(father,s_wakeup);
    frame;
end
